<template>
  <section class="app-main">
    <transition name="fade-transform" mode="out-in">
      <keep-alive :include="cachedViews">
        <router-view v-if="!$route.meta.link" :key="key" />
      </keep-alive>
    </transition>
    <iframe-toggle />
  </section>
</template>

<script>
import iframeToggle from "./IframeToggle/index";

export default {
  name: "AppMain",
  components: { iframeToggle },
  computed: {
    cachedViews() {
      let cachedViews = this.$store.state.tagsView.cachedViews;
      let index = cachedViews.indexOf("investPoolAdd");
      if (index !== -1) {
        cachedViews.splice(index, 1);
      }
      if (cachedViews.indexOf("investPoolDetail") !== -1) {
        cachedViews.splice(cachedViews.indexOf("investPoolDetail"), 1);
      }
      if (cachedViews.indexOf("Pool") !== -1) {
        cachedViews.splice(cachedViews.indexOf("Pool"), 1);
      }
      if (cachedViews.indexOf("Record") !== -1) {
        cachedViews.splice(cachedViews.indexOf("Record"), 1);
      }
      if (cachedViews.indexOf("Channel") !== -1) {
        cachedViews.splice(cachedViews.indexOf("Channel"), 1);
      }
      if (cachedViews.indexOf("Meeting") !== -1) {
        cachedViews.splice(cachedViews.indexOf("Meeting"), 1);
      }
      if (cachedViews.indexOf("Information") !== -1) {
        cachedViews.splice(cachedViews.indexOf("Information"), 1);
      }
      if (cachedViews.indexOf("Contract") !== -1) {
        cachedViews.splice(cachedViews.indexOf("Contract"), 1);
      }
      if (cachedViews.indexOf("Gen") !== -1) {
        cachedViews.splice(cachedViews.indexOf("Gen"), 1);
      }
      // console.log("===cachedViews==",cachedViews)
      return cachedViews;
    },
    key() {
      return this.$route.path;
    },
  },
};
</script>

<style lang="scss" scoped>
.app-main {
  /* 50= navbar  50  */
  min-height: calc(100vh - 50px);
  width: 100%;
  position: relative;
  overflow: hidden;
}

.fixed-header + .app-main {
  padding-top: 50px;
}

.hasTagsView {
  .app-main {
    /* 84 = navbar + tags-view = 50 + 34 */
    min-height: calc(100vh - 84px);
  }

  .fixed-header + .app-main {
    padding-top: 84px;
  }
}
</style>

<style lang="scss">
// fix css style bug in open el-dialog
.el-popup-parent--hidden {
  .fixed-header {
    padding-right: 6px;
  }
}

::-webkit-scrollbar {
  width: 6px;
  height: 6px;
}

::-webkit-scrollbar-track {
  background-color: #f1f1f1;
}

::-webkit-scrollbar-thumb {
  background-color: #c0c0c0;
  border-radius: 3px;
}
</style>
